/*
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
// Get xp connect priviledge
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

function showContactDetails() {
	window.openDialog("chrome://funambol/content/contacts-details.xul", "", "chrome, centerscreen");
}

function showCalendarDetails() {
	window.openDialog("chrome://funambol/content/calendar-details.xul", "", "chrome, centerscreen");
}

function showLogDialog() {
	window.openDialog("chrome://funambol/content/log-dialog.xul", "", "chrome, centerscreen");
}

function showProxyDialog() {
	window.openDialog("chrome://funambol/content/proxy-settings.xul", "", "chrome, centerscreen");
}

/*
 * Initialize the dialog content
 */
function initPreferences() {
    var fnblConfig = Components.classes["@mozilla.org/funambol/config;1"].getService(Components.interfaces.fnblConfig);
	
	document.getElementById("serverUrl").value = 		  fnblConfig.serverUri;	
	document.getElementById("username").value = 		  fnblConfig.username;		
	document.getElementById("password").value = 		  fnblConfig.password;	
	document.getElementById("contactCheck").checked =     fnblConfig.contactSync;
	document.getElementById("contactDetails").disabled = !document.getElementById("contactCheck").checked;
	document.getElementById("eventCheck").checked = 	  fnblConfig.eventSync;	
	document.getElementById("taskCheck").checked = 		  fnblConfig.taskSync;
	document.getElementById("calDetails").disabled =     !document.getElementById("eventCheck").checked && !document.getElementById("taskCheck").checked;
	document.getElementById("schedulerCheck").checked =   fnblConfig.isScheduledSync;
	document.getElementById("intervalList").disabled =   !document.getElementById("schedulerCheck").checked;
	document.getElementById("startupSyncCheck").checked = fnblConfig.syncAtStartup;
	document.getElementById("radioLog").selectedIndex =   fnblConfig.logLevel;
	
	document.getElementById("unitTestButton").hidden =   !fnblConfig.enableUnitTest;
    
    var intervals = new Array("5", "10", "15", "30", "45", "60");
    var syncInterval = fnblConfig.syncInterval;
    var list = document.getElementById("intervalList");
   
    for (var i=0; i<intervals.length; i++) {
        
        var interval = intervals[i];
		var suffix = " minutes"
		
		if(interval >= 60) {
		    interval /= 60;
		    suffix = " hour"
		    if(interval > 60) {
		        // plural suffix
		        suffix += "s";
		    }
		}
		list.appendItem(interval + suffix, intervals[i]);
		
		if(intervals[i] == syncInterval) {
		    list.selectedIndex = i;
		}		
    } 

	if(!Components.classes["@mozilla.org/addressbook;1"]) {
		document.getElementById("contactCheck").disabled = true;
		document.getElementById("contactDetails").disabled = true;
	}
	
	var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	
	var cal = em.getItemForID("{e2fda1a4-762b-4020-b5ad-a41df1933103}");
	var calVersion = 0;
	
	if(cal) {
		calVersion = em.getItemForID("{e2fda1a4-762b-4020-b5ad-a41df1933103}").version;
    }
	if(!Components.classes["@mozilla.org/calendar/manager;1"] || calVersion.substring(0, 3) != "0.9") {
		document.getElementById("eventCheck").disabled = true;
		document.getElementById("calDetails").disabled = true;
		document.getElementById("taskCheck").disabled = true;
	}
	if(Components.classes["@mozilla.org/calendar/manager;1"] && calVersion.substring(0, 3) != "0.9") {
		document.getElementById("calLabel").value = "[This plugin is Calendar v0.9 compatible]";
		document.getElementById("calLabel").disabled = true;
	}
		
	// Disable configuration settings during sync
	if(fnblConfig.isSyncing) {
        document.getElementById("serverUrlLabel").disabled = true;
        document.getElementById("serverUrl").disabled = true;
        document.getElementById("usernameLabel").disabled = true;
        document.getElementById("username").disabled = true;
        document.getElementById("passwordLabel").disabled = true;
        document.getElementById("password").disabled = true;
        document.getElementById("proxyButton").disabled = true;
        document.getElementById("contactCheck").disabled = true;
        document.getElementById("contactDetails").disabled = true;
        document.getElementById("eventCheck").disabled = true;
        document.getElementById("calDetails").disabled = true;
        document.getElementById("taskCheck").disabled = true;
        document.getElementById("schedulerCheck").disabled = true;
        document.getElementById("intervalList").disabled = true;
        document.getElementById("radioLog").disabled = true;
        document.getElementById("logButtonView").disabled = true;
        document.getElementById("logButtonSend").disabled = true;
        document.getElementById("unitTestButton").disabled = true;
    }
	
	// select the correct picture to show on the right side of the pref panel
	var picture = Components.classes["@mozilla.org/addressbook/cardproperty;1"] ? "icon_thunderbird_128x128.png" : 
	                                                                              "icon_sunbird_128x128.png";
	window.document.getElementById("funambolLogo1").setAttribute("src", "chrome://funambol/skin/images/" + picture);
	window.document.getElementById("funambolLogo2").setAttribute("src", "chrome://funambol/skin/images/" + picture);
	window.document.getElementById("funambolLogo3").setAttribute("src", "chrome://funambol/skin/images/" + picture);
	
	// check whether the log tab shall be selected
	if ("arguments" in window && window.arguments[1] && document.getElementById(window.arguments[1])) {
        document.getElementById("prefTabBox").selectedTab = document.getElementById(window.arguments[1]);
    }
}

function checkCalDetailsButton() {
	document.getElementById("calDetails").disabled = !document.getElementById("eventCheck").checked && !document.getElementById("taskCheck").checked;
}

function checkContactDetailsButton() {
	document.getElementById("contactDetails").disabled = !document.getElementById("contactCheck").checked;
}

function enableScheduledSync() {
	document.getElementById("intervalList").disabled = !document.getElementById("schedulerCheck").checked;
}

/*
 * Save the configuration
 */
function savePreferences() {
    var fnblConfig = Components.classes["@mozilla.org/funambol/config;1"].getService(Components.interfaces.fnblConfig);
	
	if(document.getElementById("serverUrl") != null) {
        
        fnblConfig.serverUri = 	     document.getElementById("serverUrl").value;	
		fnblConfig.username = 	     document.getElementById("username").value;	
		fnblConfig.password = 	     document.getElementById("password").value;	
		fnblConfig.contactSync =     document.getElementById("contactCheck").checked;	
		fnblConfig.eventSync = 	     document.getElementById("eventCheck").checked;
		fnblConfig.taskSync = 	     document.getElementById("taskCheck").checked;	
		fnblConfig.logLevel = 	     document.getElementById("radioLog").selectedIndex;	
		
		fnblConfig.isScheduledSync = document.getElementById("schedulerCheck").checked;
		fnblConfig.syncAtStartup = 	 document.getElementById("startupSyncCheck").checked;

		if(document.getElementById("intervalList").selectedItem.value) {
		    fnblConfig.syncInterval = document.getElementById("intervalList").selectedItem.value;
	    }
		fnblConfig.save();
		
		// if the opener window is the sync dialog, initialize it
        if(window.opener.initSyncDialog) {
            window.opener.initSyncDialog();
        }
	}
}

/*
 * Start the Unit Test
 */
function startUnitTest() {
    var fnblComponent = Components.classes["@mozilla.org/funambol/component;1"].getService(Components.interfaces.fnblComponent);
	fnblComponent.startUnitTest();	
}

/** Methods used for saving every single config property (only for the Posix versions) */

var fnblConfig = Components.classes["@mozilla.org/funambol/config;1"].getService(Components.interfaces.fnblConfig);

function saveServerUrl() {
    fnblConfig.serverUri = document.getElementById("serverUrl").value;
    fnblConfig.save();
}

function saveUsername() {
    fnblConfig.username = document.getElementById("username").value;
    fnblConfig.save();
}

function savePassword() {
    fnblConfig.password = document.getElementById("password").value;
    fnblConfig.save();
}

function saveLogLevel() {
    fnblConfig.logLevel = document.getElementById("radioLog").selectedIndex;
    fnblConfig.save();
}

function checkContactDetailsButtonPosix() {
    checkContactDetailsButton();
    fnblConfig.contactSync = document.getElementById("contactCheck").checked;
    fnblConfig.save();
    // if the opener window is the sync dialog, initialize it
    if(window.opener.initSyncDialog) {
        window.opener.initSyncDialog();
    }
}

function checkCalDetailsButtonPosix() {
    checkCalDetailsButton();
    fnblConfig.eventSync = document.getElementById("eventCheck").checked;
	fnblConfig.taskSync = document.getElementById("taskCheck").checked;
	fnblConfig.save();
    // if the opener window is the sync dialog, initialize it
    if(window.opener.initSyncDialog) {
        window.opener.initSyncDialog();
    }
}

function enableScheduledSyncPosix() {
    enableScheduledSync();
    fnblConfig.isScheduledSync = document.getElementById("schedulerCheck").checked;
    fnblConfig.save();
}

function saveSyncInterval() {
    if(document.getElementById("intervalList").selectedItem.value) {
	    fnblConfig.syncInterval = document.getElementById("intervalList").selectedItem.value;
	    fnblConfig.save();
    }
}

function enableStartupSyncPosix() {
    fnblConfig.syncAtStartup = document.getElementById("startupSyncCheck").checked;
    fnblConfig.save();
}
